#!/bin/bash
export PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:$PATH

: '
Copyright (C) 2022 - now  HaoZi Technology Co., Ltd.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published
by the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
'

source <(curl -f -s --connect-timeout 10 --retry 3 https://dl.cdn.haozi.net/panel/public.sh)
if [ $? -ne 0 ]; then
    echo "下载 public.sh 失败,请检查网络或稍后重试。"
    echo "Download public.sh failed, please check the network or try again later."
    exit 1
fi

channel=${1}
version=${2}
in_china=$(curl --retry 2 -m 10 -L https://www.qualcomm.cn/cdn-cgi/trace 2>/dev/null | grep -qx 'loc=CN' && echo "true" || echo "false")

if [ ${OS} == "rhel" ]; then
    dnf makecache -y
    dnf install podman podman-compose podman-docker -y
elif [ ${OS} == "debian" ] || [ ${OS} == "ubuntu" ]; then
    apt-get update
    apt-get install podman podman-compose podman-docker containers-storage -y
else
    error "不支持的操作系统"
fi

# Debian\OpenCloudOS\openEuler 下可能没有 /etc/containers/storage.conf 文件
if [ ! -f /etc/containers/storage.conf ]; then
    if [ -f /usr/share/containers/storage.conf ]; then
        cp /usr/share/containers/storage.conf /etc/containers/storage.conf
    else
        touch /etc/containers/storage.conf
    fi
fi

ln -sf /usr/bin/podman /usr/bin/docker

if ${in_china}; then
    cat >>/etc/containers/registries.conf <<EOF
[[registry]]
location = "docker.io"
[[registry.mirror]]
location = "docker.1ms.run"
EOF
fi

systemctl enable --now podman
systemctl enable --now podman.socket
systemctl enable --now podman-restart

panel-cli app write podman ${channel} ${version}
echo -e ${HR}
echo "安装完成"
echo -e ${HR}